unit LogoMain;

interface

uses Windows, Classes, Forms, Controls, Menus, CryptCon,
  Dialogs, StdCtrls, Buttons, ExtCtrls, ComCtrls, ElMTree, ElTree,
  ElImgLst, ElStack, frmRecProp, About, MD5Unit, IdeaUnit, ElTools, frmPassword,
  ShellApi, Graphics, ClipBrd, Registry, KeeperOpts,   
  ElStrUtils, BaseComp, ElTray, MRU, ElPopBtn, ElIni, FormPers, ToolWin,
  ElCaption, ElPanel, ElToolBar;

type
  TLogoAppForm = class(TForm)
    LogoAppMenu: TMainMenu;
    FileMenu: TMenuItem;
    FileNewItem: TMenuItem;
    FileOpenItem: TMenuItem;
    FileSaveItem: TMenuItem;
    FileExitItem: TMenuItem;
    OpenDialog: TOpenDialog;
    SaveDialog: TSaveDialog;
    Help1: TMenuItem;
    AboutItem: TMenuItem;
    ElTree: TElTree;
    CloseBtn: TMenuItem;
    PopupMenu: TPopupMenu;
    NewFoldItem: TMenuItem;
    NewRecItem: TMenuItem;
    DeleteItem: TMenuItem;
    N1: TMenuItem;
    N3: TMenuItem;
    PropItem: TMenuItem;
    ElImgList: TElImageList;
    Record1: TMenuItem;
    Newfolder1: TMenuItem;
    Newrecord1: TMenuItem;
    N4: TMenuItem;
    Delete1Item: TMenuItem;
    N5: TMenuItem;
    Prop1Item: TMenuItem;
    ContentsItem: TMenuItem;
    N6: TMenuItem;
    N7: TMenuItem;
    RecentItem: TMenuItem;
    GoItem: TMenuItem;
    Go1Item: TMenuItem;
    FontDlg: TFontDialog;
    TreeFontItem: TMenuItem;
    CopyItem: TMenuItem;
    PrintSetDlg: TPrinterSetupDialog;
    PrintSetupItem: TMenuItem;
    PrintItem: TMenuItem;
    PrintDlg: TPrintDialog;
    OptionsItem: TMenuItem;
    ToTrayItem: TMenuItem;
    Tray: TElTrayIcon;
    ElMRU: TElMRU;
    RecentPopup: TPopupMenu;
    ElIniFile: TElIniFile;
    ElFormPersist: TElFormPersist;
    PasswItem: TMenuItem;
    FormCaption: TElFormCaption;
    CopyPswItem: TMenuItem;
    KeepPswItem: TMenuItem;
    N8: TMenuItem;
    SetPswItem: TMenuItem;
    ReopenFileItem: TMenuItem;
    ParanoyaItem: TMenuItem;
    ElToolBar1: TElToolBar;
    ExitBtn: TElToolButton;
    NewBtn: TElToolButton;
    ElToolButton3: TElToolButton;
    OpenBtn: TElToolButton;
    SaveBtn: TElToolButton;
    PrintBtn: TElToolButton;
    ElToolButton2: TElToolButton;
    NewFolderBtn: TElToolButton;
    NewRecBtn: TElToolButton;
    ElToolButton6: TElToolButton;
    DelBtn: TElToolButton;
    PropBtn: TElToolButton;
    ElToolButton1: TElToolButton;
    GoBtn: TElToolButton;
    CopyBtn: TElToolButton;
    procedure FormCreate(Sender: TObject);
    procedure FileExit(Sender: TObject);
    procedure FileNew(Sender: TObject);
    procedure FileOpen(Sender: TObject);
    procedure FileSave(Sender: TObject);
    procedure FileSaveAs(Sender: TObject);
    procedure About(Sender: TObject);
    procedure CloseBtnClick(Sender: TObject);
    procedure ElTreeMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure NewFoldItemClick(Sender: TObject);
    procedure PropItemClick(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure DeleteItemClick(Sender: TObject);
    procedure NewRecItemClick(Sender: TObject);
    procedure ElTreeStartDrag(Sender: TObject;
      var DragObject: TDragObject);
    procedure ElTreeDragOver(Sender, Source: TObject; X, Y: Integer;
      State: TDragState; var Accept: Boolean);
    procedure ElTreeDragDrop(Sender, Source: TObject; X, Y: Integer);
    procedure Record1Click(Sender: TObject);
    procedure ElTreeItemFocused(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure ContentsItemClick(Sender: TObject);
    function AppEventsHelp(Command: Word; Data: Integer;
      var CallHelp: Boolean): Boolean;
    procedure GoItemClick(Sender: TObject);
    procedure TreeFontItemClick(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure CopyBtnClick(Sender: TObject);
    procedure PrintSetupItemClick(Sender: TObject);
    procedure PrintItemClick(Sender: TObject);
    procedure ToTrayItemClick(Sender: TObject);
    procedure RxTrayDblClick(Sender: TObject);
    procedure AppEventsMinimize(Sender: TObject);
    procedure AppEventsRestore(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure PasswItemClick(Sender: TObject);
    procedure ElMRUClick(Sender: TObject; Entry: TElMRUEntry);
    procedure FormCaptionButtonClick(Sender: TObject;
      Button: TElCaptionButton);
    procedure CopyPswItemClick(Sender: TObject);
    procedure ElFormPersistRestore(Sender: TObject);
    procedure KeepPswItemClick(Sender: TObject);
    procedure SetPswItemClick(Sender: TObject);
    procedure ReopenFileItemClick(Sender: TObject);
    procedure ParanoyaItemClick(Sender: TObject);
  private
    FFileName: String;
    FOpened  : boolean;
    FChanged : boolean;
    FMTree   : TElMTree;
    LoadStack: TElStack;
    SelItem,
    DragItem : TElTreeItem;
    function FileClose : boolean;
    function SaveFile(FileName : string) : Boolean;
    function LoadFile(FileName, Passw : string; UseGivenPassword : boolean) : Boolean;
    procedure OnItemDelete(Sender : TObject; Item : TElMTreeItem; Data : pointer);
    procedure CreateRecord(IsFolder : boolean);
    procedure OnItemSave(Sender : TObject; Item : TElMTreeItem; Stream : TStream);
    procedure OnItemLoad(Sender : TObject; Item : TElMTreeItem; Stream : TStream);
    procedure UpdateItem(Item : TElTreeItem);
  public
    FilePassword : string;
    function PropsEdit(Item : TElTreeItem) : Boolean;
  end;

var
  LogoAppForm: TLogoAppForm;

implementation

uses SysUtils, LogoStrs, Printers, ElOpts;

{$R *.DFM}

procedure TLogoAppForm.FormCreate(Sender: TObject);
begin
  Options := TKeeperOpts.Create(Self);
  Options.Storage := ElIniFile;
  Options.StorageType := eosElIni;
  Options.Load;
  ElTree.Restore;
  ElMRU.Restore;
  if Options.ShowPassword then PasswItem.Checked := true;
  if Options.ToTray then ToTrayItem.Checked := true;
  if Options.ReopenFile then ReopenFileItem.Checked := true;
  if Options.SaveKeys then ParanoyaItem.Checked := true;
  if Options.KeepPassword then KeepPswItem.Checked := true;
  Application.OnHelp := AppEventsHelp;
  Application.OnRestore := Self.AppEventsRestore;
  Application.OnMinimize := Self.AppEventsMinimize;
  FMTree := TElMTree.Create;
  FMTree.OnItemDelete:=OnItemDelete;
  FMTree.OnItemSave:=OnItemSave;
  FMTree.OnItemLoad:=OnItemLoad;
  LoadStack:=TElStack.Create;
  FOpened:=false;
  AboutBox:=TAboutBox.Create(Self);
  FFileName := LoadStr(sUntitled);
  FormCaption.Texts[3].Caption := FFileName;
  if OpenDialog.InitialDir='' then OpenDialog.InitialDir := ExtractFileDir(ParamStr(0));
  if SaveDialog.InitialDir='' then SaveDialog.InitialDir := ExtractFileDir(ParamStr(0));
end;

procedure TLogoAppForm.FileNew(Sender: TObject);
begin
  if FOpened then
     if not FileClose then exit;
  ElTree.Items.Clear;
  FMTree.Clear;
  DeleteItem.Enabled := false;
  PropItem.Enabled   := false;
  Delete1Item.Enabled := false;
  Prop1Item.Enabled   := false;
  GoItem.Enabled := false;
  GoBtn.Enabled := false;
  Go1Item.Enabled := false;
  PropBtn.Enabled := false;
  DelBtn.Enabled :=false;
  CopyBtn.Enabled := false;
  CopyItem.Enabled := false;
  SelItem := nil;
  FChanged  := false;
  FOpened := true;
  FilePassword := '';
  FFileName := LoadStr(sUntitled);
  FormCaption.Texts[3].Caption := FFileName;
end;

procedure TLogoAppForm.FileOpen(Sender: TObject);
begin
  if FOpened then
     if not FileClose then exit;
  if OpenDialog.Execute then
  begin
    if LoadFile(OpenDialog.FileName, '', false) then
    begin
      FFileName := OpenDialog.FileName;
      SelItem := nil; 
      FChanged := false;
      FOpened := true;
      FormCaption.Texts[3].Caption := FFileName;
    end;
  end;
end;

procedure TLogoAppForm.FileSave(Sender: TObject);
begin
  if FFileName = LoadStr(sUntitled) then
    FileSaveAs(Sender)
  else
    SaveFile(FFileName);
end;

procedure TLogoAppForm.FileSaveAs(Sender: TObject);
begin
  if SaveDialog.Execute then
  begin
    if FileExists(SaveDialog.FileName) then
      if MessageDlg(FmtLoadStr(sOverwrite, [SaveDialog.FileName]),
        mtConfirmation, mbYesNoCancel, 0) <> idYes then Exit;
    if SaveFile(SaveDialog.FileName) then
    begin
      FFileName := SaveDialog.FileName;
      FChanged  := false;
      FormCaption.Texts[3].Caption := FFileName;
      ElMRU.Sections[0].Add(FFileName, 0);
    end;
  end;
end;

function TLogoAppForm.FileClose;
begin
  result := true;
  if not FOpened then exit;
  if FChanged then
  begin
    case MessageDlg(LoadStr(sSaveOnCLose), mtWarning, [mbYes, mbNo, mbCancel], 0) of
      id_Yes: begin
                FileSave(Self);
                if FChanged then result:=false;
              end;
      id_No:  FChanged := false;
      id_Cancel: result:=false;
    end;
  end;
  if Result then
  begin
    FOpened := false;
    SelItem := nil; 
    FMTree.Clear;
    ElTree.Items.Clear;
    FilePassword := '';
    FFileName := LoadStr(sUntitled);
    FormCaption.Texts[3].Caption := FFileName;
  end;
end;

procedure TLogoAppForm.FileExit(Sender: TObject);
begin
  Close;
end;

procedure TLogoAppForm.About(Sender: TObject);
begin
  AboutBox.ShowModal;
end;

function TLogoAppForm.SaveFile(FileName : string) : Boolean;  { private }
var Stream : TStream;
    Passw  : string;
    MD5    : TMD5;
    MemStream : TDirectMemoryStream;
    arr : array [1..17] of char;
    IDEA: TIDEA;

begin
  MemStream := nil;
  PasswordDlg.Password.Text:='';
  PasswordDlg.ConfPassword.visible:=true;
  PasswordDlg.ConfLabel.Visible:=true;
  PasswordDlg.ConfPassword.Text:='';
  result:=false;
  if not Options.KeepPassword then
  begin
    repeat
      if PasswordDlg.ShowModal = mrCancel then exit;
      if PasswordDlg.Password.Text<>PasswordDlg.ConfPassword.Text then
        MessageDlg (LoadStr(sPswNotMatch), mtError, [mbOk], 0)
      else
      if PasswordDlg.Password.Text='' then
         MessageDlg (LoadStr(sPswEmpty), mtError, [mbOk], 0)
      else break;
    until false;
    Passw := PasswordDlg.Password.Text;
    PasswordDlg.Password.Text:='';
    PasswordDlg.ConfPassword.Text:='';
  end else Passw := FilePassword;
  MD5:=TMD5.Create;
  MD5.InputType:=SourceString;
  MD5.InputString:=Passw;
  MD5.pOutputArray:=@arr;
  MD5.MD5_Hash;
  arr[17]:=#0;
  MD5.Free;
  Stream := nil;
  try
    MemStream := TDirectMemoryStream.Create;
    FMTree.SaveToStream(MemStream);
    MemStream.Seek(0, soFromBeginning);
    if FileExists(FileName) then
      Stream := TFileStream.Create(FileName, fmOpenWrite or fmShareDenyWrite)
    else
      Stream := TFileStream.Create(FileName, fmCreate or fmShareDenyWrite);
    IDEA := TIDEA.Create(self);
    try
      IDEA.InputType := SourceStream;
      IDEA.CipherMode := ECBMode;
      IDEA.IVector:=Passw;
      IDEA.Key:=StrPas(@arr);
      IDEA.InputStream:=MemStream;
      IDEA.OutputStream:=Stream;
      IDEA.EncipherData(False);
    finally
      IDEA.free;
    end;
    MemStream.Free;
    Stream.Free;
    FChanged := false;
  except
    on E:Exception do
    begin
      MessageDlg(FmtLoadStr(sFailSave, [FileName]), mtError, [mbOk], 0);
      result := false;
      MemStream.Free;
      Stream.Free;
      exit;
    end;
  end;
  result := true;
end;  { SaveFile }

function TLogoAppForm.LoadFile;
var Stream : TFileStream;
    MD5    : TMD5;
    MemStream : TDirectMemoryStream;
    arr : array [1..17] of char;
    IDEA: TIDEA;

begin
  result:=False;
  if not FileExists(FileName) then exit;
  if not UseGivenPassword then
  begin
    PasswordDlg.Password.Text:='';
    PasswordDlg.ConfPassword.visible:=false;
    PasswordDlg.ConfLabel.Visible:=false;
    PasswordDlg.ConfPassword.Text:='';
    if PasswordDlg.ShowModal = mrCancel then exit;
    Passw := PasswordDlg.Password.Text;
    PasswordDlg.Password.Text:='';
  end;
  MD5:=TMD5.Create;
  MD5.InputType:=SourceString;
  MD5.InputString:=Passw;
  MD5.pOutputArray:=@arr;
  MD5.MD5_Hash;
  arr[17]:=#0;
  MD5.Free;
  MemStream := nil;
  Stream := nil;
  try
    MemStream := TDirectMemoryStream.Create;
    Stream :=TFileStream.Create(FileName, fmOpenRead or fmShareDenyWrite);
    if Passw<>'' then
    begin
      IDEA := nil;
      try
        IDEA := TIDEA.Create(self);
        IDEA.InputType := SourceStream;
        IDEA.CipherMode := ECBMode;
        IDEA.IVector:=Passw;
        IDEA.Key:=StrPas(@arr);
        IDEA.InputStream:=Stream;
        IDEA.OutputStream:=MemStream;
        IDEA.DecipherData(False);
        MemStream.Seek(0, soFromBeginning);
        ElTree.Items.BeginUpdate;
        try
          FMTree.LoadFromStream(MemStream);
        finally
          ElTree.Items.EndUpdate;
        end;
      finally
        IDEA.free;
      end;
    end else
      FMTree.LoadFromStream(Stream);
    MemStream.Free;
    Stream.Free;
    result := true;
  except
    on E:Exception do
    begin
      MessageDlg(FmtLoadStr(sFailLoad, [FileName]), mtError, [mbOk], 0);
      result := false;
      FMTree.Clear;
      ElTree.Items.Clear;
      MemStream.Free;
      Stream.Free;
      exit;
    end;
  end;
  ElMRU.Sections[0].Add(FileName, 0);
  if result then
  begin
    Options.LastFile := FileName;
    FilePassword := Passw;
  end;
end;

procedure TLogoAppForm.CloseBtnClick(Sender: TObject);
begin
  if FileClose then
  begin
    GoItem.Enabled := false;
    GoBtn.Enabled := false;
    Go1Item.Enabled := false;
    DeleteItem.Enabled := false;
    PropItem.Enabled   := false;
    Delete1Item.Enabled := false;
    Prop1Item.Enabled   := false;
    PropBtn.Enabled := false;
    DelBtn.Enabled := false;
    CopyBtn.Enabled := false;
    CopyItem.Enabled := false;
    SelItem := nil;
    FChanged  := false;
  end;
end;

procedure TLogoAppForm.OnItemDelete(Sender : TObject; Item : TElMTreeItem; Data : pointer);
var E : PEntryRec;
begin
  E:=PEntryRec(Data);
  Dispose(E);
end;

procedure TLogoAppForm.ElTreeMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  if Button = mbRight then
  begin
    SelItem := ElTree.ItemFocused;
    DeleteItem.Enabled := SelItem<>nil;
    PropItem.Enabled   := SelItem<>nil;
    Delete1Item.Enabled := SelItem <>nil;
    Prop1Item.Enabled   := SelItem <>nil;
    PropBtn.Enabled := SelItem <>nil;
    DelBtn.Enabled := SelItem <>nil;
    GoItem.Enabled := SelItem <>nil;
    Go1Item.Enabled := SelItem <>nil;
    GoBtn.Enabled := SelItem <>nil;
    CopyBtn.Enabled := SelItem <>nil;
    CopyItem.Enabled := SelItem <>nil;
  end;
end;

procedure TLogoAppForm.NewFoldItemClick(Sender: TObject);
begin
  CreateRecord(true);
end;

procedure TLogoAppForm.CreateRecord(IsFolder : boolean);
var Item,
    Item1 : TElTreeItem;
    MItem : TElMTreeItem;
    Entry : PEntryRec;
begin
  New(Entry);
  if (SelItem<>nil) then
  begin
    if (PEntryRec(TElMTreeItem(SelItem.Data)^.Data)^.Group)
      then Item1 := SelItem
      else Item1 := SelItem.Parent;
    Item := ElTree.Items.AddItem(Item1);
    if Item1 = nil
       then MItem := FMTree.AddItem(nil, Entry)
       else MItem := FMTree.AddItem(Item1.Data, Entry);
  end
  else
  begin
    Item := ElTree.Items.AddItem(nil);
    MItem := FMTree.AddItem(nil, Entry);
  end;
  Item.Data := MItem;
  Entry^.Group := IsFolder;
  if IsFolder then
  begin
    Item.ImageIndex:=0;
    Item.StateImageIndex := 1;
  end else Item.ImageIndex := 2;
  SelItem := item;
  if not PropsEdit(SelItem) then
  begin
    FMTree.DeleteItem(MItem);
    ElTree.Items.DeleteItem(SelItem);
    SelItem := nil;
  end else
  begin
    SelItem.Expanded:=true;
    FChanged := true;
    FOpened := true;
  end;
end;

procedure TLogoAppForm.PropItemClick(Sender: TObject);
begin
  PropsEdit(SelItem);
end;

procedure TLogoAppForm.OnItemSave(Sender : TObject; Item : TElMTreeItem; Stream : TStream);  { protected }
var Entry : PEntryRec;
    P : PChar;
    i : integer;
begin
  Entry := PEntryRec(Item^.Data);
  Stream.WriteBuffer(Entry^.Group, Sizeof(boolean));
  i := Length(Entry^.Site);
  Stream.WriteBuffer(i, sizeof(integer));
  P := PChar(Entry^.Site);
  Stream.WriteBuffer(P^, i);
  if Entry^.Group then exit
  else
  begin
        i := Length(Entry^.Location);
    Stream.WriteBuffer(i, sizeof(integer));
    P := PChar(Entry^.Location);
    Stream.WriteBuffer(P^, i);
        i := Length(Entry^.UName);
    Stream.WriteBuffer(i, sizeof(integer));
    P := PChar(Entry^.UName);
    Stream.WriteBuffer(P^, i);
        i := Length(Entry^.Acct);
    Stream.WriteBuffer(i, sizeof(integer));
    P := PChar(Entry^.Acct);
    Stream.WriteBuffer(P^, i);
        i := Length(Entry^.Pswd);
    Stream.WriteBuffer(i, sizeof(integer));
    P := PChar(Entry^.Pswd);
    Stream.WriteBuffer(P^, i);
        i := Length(Entry^.Info);
    Stream.WriteBuffer(i, sizeof(integer));
    P := PChar(Entry^.Info);
    Stream.WriteBuffer(P^, i);
  end;
end;  { OnItemSave }

procedure TLogoAppForm.OnItemLoad(Sender : TObject; Item : TElMTreeItem; Stream : TStream);  { protected }
var
    VItem, Parent : TElTreeItem;
    Entry : PEntryRec;
    i : integer;
    p : PChar;

begin
  New(Entry);
  Parent := nil;
  if not LoadStack.Empty then
  begin
    Parent := TElTreeItem(LoadStack.Pop);
    if Parent.Data<>Item^.Parent then
    begin
      while (not LoadStack.Empty) do
      begin
        Parent := TElTreeItem(LoadStack.Pop);
        if Parent.Data=Item^.Parent then
        begin
          LoadStack.Push(Parent);
          break;
        end;
      end;
      if LoadStack.Empty then Parent := nil;
    end
    else
      LoadStack.Push(Parent);
  end;
  if Parent<>nil then
  begin
    VItem := ElTree.Items.AddItem(Parent);
    VItem.Data := Item;
  end else
  begin
    VItem  := ElTree.Items.AddItem(nil);
    VItem.Data := Item;
  end;
  Item^.Data:=Entry;
  LoadStack.Push(VItem);
  Stream.ReadBuffer(Entry^.Group, sizeof(boolean));

  Stream.ReadBuffer(i, sizeof (integer));
  GetMem(P, i+1);
  P[i]:=#0;
  Stream.ReadBuffer(p^, i);
  Entry^.Site := StrPas(p);

  FreeMem(p);
  if Entry^.Group then
  begin
    UpdateItem(VItem);
    exit;
  end;
  Stream.ReadBuffer(i, sizeof (integer));
  GetMem(P, i+1);
  P[i]:=#0;
  Stream.ReadBuffer(p^, i);
  Entry^.Location := StrPas(p);

  FreeMem(p);
  Stream.ReadBuffer(i, sizeof (integer));
  GetMem(P, i+1);
  P[i]:=#0;
  Stream.ReadBuffer(p^, i);
  Entry^.UName := StrPas(p);
  FreeMem(p);
  Stream.ReadBuffer(i, sizeof (integer));
  GetMem(P, i+1);
  P[i]:=#0;
  Stream.ReadBuffer(p^, i);
  Entry^.Acct := StrPas(p);
  FreeMem(p);
  Stream.ReadBuffer(i, sizeof (integer));
  GetMem(P, i+1);
  P[i]:=#0;
  Stream.ReadBuffer(p^, i);
  Entry^.Pswd := StrPas(p);
  FreeMem(p);
  Stream.ReadBuffer(i, sizeof (integer));
  GetMem(P, i+1);
  P[i]:=#0;
  Stream.ReadBuffer(p^, i);
  Entry^.Info := StrPas(p);
  FreeMem(p);

  UpdateItem(VItem);
end;  { OnItemLoad }

procedure TLogoAppForm.FormCloseQuery(Sender: TObject;
  var CanClose: Boolean);
begin
  CanClose := FileClose;
end;

procedure TLogoAppForm.DeleteItemClick(Sender: TObject);
begin
  if (SelItem = nil) or (SelItem.Data = nil) then exit;
  if MessageDlg(LoadStr(sConfDelete), mtWarning, [mbYes, mbNo], 0)=mrNo then exit;
  FMTree.DeleteItem(TElMTreeItem(SelItem.Data));
  ElTree.Items.DeleteItem(SelItem);
  FChanged := true;
  SelItem := nil;
end;

procedure TLogoAppForm.NewRecItemClick(Sender: TObject);
begin
  CreateRecord(false);
end;

procedure TLogoAppForm.UpdateItem(Item : TElTreeItem);
var Entry : PEntryRec;
begin
  if Item.Data=nil then exit;
  Entry := PEntryRec(TElMTreeItem(Item.Data)^.Data);
  ElTree.IsUpdating:=true;
  Item.Text:=Entry^.Site;
  Item.ColumnText.Clear;
  Item.ColumnText.Add(Entry^.Location);
  Item.ColumnText.Add(Entry^.UName);
  Item.ColumnText.Add(Entry^.Acct);
  Item.ColumnText.Add(Entry^.Pswd);
  Item.ColumnText.Add(Entry^.Info);
  if Entry^.Group then
  begin
    Item.ImageIndex:=0;
    Item.StateImageIndex := 1;
  end else Item.ImageIndex := 2; 
  ElTree.IsUpdating:=false;
end;

function TLogoAppForm.PropsEdit(Item : TElTreeItem) : Boolean;  { public }
var s: string;
begin
  result :=false;
  if (SelItem = nil) or (SelItem.Data = nil) then exit;
  if PEntryRec(TElMTreeItem(SelItem.Data)^.Data)^.Group then
  begin
    s:=InputBox(PChar(Application.Title), LoadStr(sFolderName),PEntryRec(TElMTreeItem(SelItem.Data)^.Data)^.Site);
    if s<>PEntryRec(TElMTreeItem(SelItem.Data)^.Data)^.Site then
    begin
      FChanged := true;
      SelItem.Text := s;
      PEntryRec(TElMTreeItem(SelItem.Data)^.Data)^.Site:=s;
      result := true;
    end;
  end else
  begin
    with TRecPropsForm.Create(Self) do
    begin
      try
        Entry := PEntryRec(TElMTreeItem(Self.SelItem.Data)^.Data);
        SetData;
        if ShowModal = mrOk then
        begin
          GetData;
          Self.UpdateItem(SelItem);
          Self.FChanged := true;
          result := true;
        end;
      finally
        Free;
      end;
    end;
  end;
end;  { PropsEdit }

type TElDragObject = class (TDragControlObject)
        function GetDragCursor(Accepted: Boolean; X, Y: Integer): TCursor; override;
     end;

function TElDragObject.GetDragCursor(Accepted: Boolean; X, Y: Integer): TCursor;
begin
  if Control is TElTree then
  begin
    if ((Control as TElTree).GetItemAtY(Y)<>nil) or (Accepted) then
       Result := (Control as TElTree).DragCursor else
       Result := crNoDrop;
  end else result:=inherited GetDragCursor(Accepted,X,Y);
end;

procedure TLogoAppForm.ElTreeStartDrag(Sender: TObject;
  var DragObject: TDragObject);
begin
  DragItem:=ElTree.ItemFocused;
  DragObject:=TElDragObject.Create(ElTree);
end;

procedure TLogoAppForm.ElTreeDragOver(Sender, Source: TObject; X,
  Y: Integer; State: TDragState; var Accept: Boolean);
var TSI:TElTreeItem;
begin
  Accept:=false;
  if Source<>ElTree then exit;
  TSI:=ElTree.GetItemAtY(Y);
  if TSI = nil then
  begin
    Accept:=true;
    exit;
  end;
  if ((not TSI.IsUnder(DragItem)) and (PEntryRec(TElMTreeItem(TSI.Data)^.Data)^.Group)) then Accept:=true;
end;

procedure TLogoAppForm.ElTreeDragDrop(Sender, Source: TObject; X,
  Y: Integer);
var TSI :TElTreeItem;
begin
  TSI:=ElTree.GetItemAtY(Y);
  if ((TSI<>nil) and (not TSI.IsUnder(DragItem)) and (PEntryRec(TElMTreeItem(TSI.Data)^.Data)^.Group))
  or (TSI = nil) then
  begin
    DragItem.MoveTo(TSI);
    if TSI<>nil then
      FMTree.MoveTo(TElMTreeItem(DragItem.Data), TElMTreeItem(TSI.Data))
    else
      FMTree.MoveTo(TElMTreeItem(DragItem.Data), nil);
    FChanged := true;
  end;
  DragItem := nil;
end;

procedure TLogoAppForm.Record1Click(Sender: TObject);
begin
  SelItem := ElTree.ItemFocused;
  DeleteItem.Enabled := SelItem<>nil;
  PropItem.Enabled   := SelItem<>nil;
  Delete1Item.Enabled := SelItem <>nil;
  Prop1Item.Enabled   := SelItem <>nil;
  PropBtn.Enabled := SelItem <>nil;
  DelBtn.Enabled := SelItem <>nil;
  GoItem.Enabled := SelItem <>nil;
  Go1Item.Enabled := SelItem <>nil;
  GoBtn.Enabled := SelItem <>nil;
  CopyBtn.Enabled := SelItem <>nil;
  CopyItem.Enabled := SelItem <>nil;
end;

procedure TLogoAppForm.ElTreeItemFocused(Sender: TObject);
begin                        
  SelItem := ElTree.ItemFocused;
  DeleteItem.Enabled := SelItem<>nil;
  PropItem.Enabled   := SelItem<>nil;
  Delete1Item.Enabled := SelItem <>nil;
  Prop1Item.Enabled   := SelItem <>nil;
  DelBtn.Enabled := SelItem <>nil;
  GoItem.Enabled := SelItem <>nil;
  PropBtn.Enabled := SelItem <>nil;
  Go1Item.Enabled := SelItem <>nil;
  GoBtn.Enabled := SelItem <>nil;
  CopyBtn.Enabled := SelItem <>nil;
  CopyItem.Enabled := SelItem <>nil;
end;

procedure TLogoAppForm.FormClose(Sender: TObject;
  var Action: TCloseAction);
var Reg : TRegistry;

begin
  Action := caFree;
  ElTree.Items.Clear;
  FMTree.Clear;
  Reg := nil;
  try
    try
      Reg := TRegistry.Create;
      Reg.OpenKey('Software\EldoS\Keeper', true);
      Reg.WriteString('OpenDir', OpenDialog.InitialDir);
      Reg.WriteString('SaveDir', SaveDialog.InitialDir);
      Reg.CloseKey;
    finally
      Reg.Free;
    end;
  except
    on E : Exception do ;
  end;
end;

procedure TLogoAppForm.ContentsItemClick(Sender: TObject);
begin
  Application.HelpCommand(HELP_FINDER, 0);
end;           

function TLogoAppForm.AppEventsHelp(Command: Word; Data: Integer;
  var CallHelp: Boolean): Boolean;
begin
  if (Command = HELP_CONTEXT) and (Data = 0) then
  begin
    CallHelp := false;
    Application.HelpCommand(HELP_FINDER, 0);
  end;
  result := true;
end;

procedure TLogoAppForm.GoItemClick(Sender: TObject);
begin
 if (SelItem = nil) or (SelItem.Data = nil) then exit;
 if PEntryRec(TElMTreeItem(SelItem.Data)^.Data)^.Group then exit;
 ShellExecute(0,'open',PChar(PEntryRec(TElMTreeItem(SelItem.Data)^.Data)^.Location),nil, nil, SW_SHOWNORMAL);
end;

procedure TLogoAppForm.TreeFontItemClick(Sender: TObject);
var Reg : TRegistry;
    St  : TFontStyles;

begin
  FontDlg.Font.Assign(ElTree.Font);
  if FontDlg.Execute then
  begin
    ElTree.Font.Assign(FontDlg.Font);
    ElTree.TextColor := FontDlg.Font.Color;
    Reg:=nil;
    try
      try
        Reg:=TRegistry.Create;
        Reg.OpenKey('Software\EldoS\Keeper', true);
        Reg.WriteString('FontName', ElTree.Font.Name);
        Reg.WriteInteger('FontCharset',Integer(ElTree.Font.Charset));
        Reg.WriteInteger('FontSize',ElTree.Font.Size);
        St := ElTree.Font.Style;
        Reg.WriteBinaryData('FontStyles', St, sizeof(TFontStyles));
      finally
        Reg.Free;
      end;
    except
      on E: Exception do ;
    end;
  end;
end;

procedure TLogoAppForm.FormDestroy(Sender: TObject);
var i : integer;
begin
  if Options.SaveKeys then
  begin
    for i := 0 to ElMRU.Sections.Count -1 do ElMRU.Sections[i].Clear;
    Options.LastFile := '';
  end;
  ElMRU.Save;
  ElTree.Save;
  Options.Save;
  ElIniFile.Save;
end;

procedure TLogoAppForm.CopyBtnClick(Sender: TObject);
var C : TClipboard;
    Entry : PEntryRec;
    S : TStringList;
begin
  if ElTree.ItemFocused = nil then exit;
  Entry := PEntryRec(TElMTreeItem(ElTree.ItemFocused.Data)^.Data);
  C := TClipboard.Create;
  S := TStringList.Create;
  if Entry.Group
     then S.Add('Group name: '+ Entry.Site)
     else S.Add('Site/Program name: '+ Entry.Site);
  if not Entry.Group then
  begin
    if Entry.Location <> '' then S.Add('Location/address: ' + Entry.Location);
    if Entry.UName <> '' then S.Add('User name: ' + Entry.UName);
    if Entry.Acct <> '' then S.Add('Account #: '+ Entry.Acct);
    if Entry.Pswd <> '' then S.Add('Password: '+ Entry.Pswd);
    if Entry.Info <> '' then S.Add('Additional info: '+ Entry.Info);
  end;
  C.AsText := S.Text;
  S.Free;
  C.Free;
end;

procedure TLogoAppForm.PrintSetupItemClick(Sender: TObject);
begin
  PrintSetDlg.Execute;
end;

procedure TLogoAppForm.PrintItemClick(Sender: TObject);
var
  PrintText: TextFile;  { declare a text-file variable }
  i: integer;
  L: TStringList;

  procedure IntPrepare(Item:TElTreeItem; Index: integer; var ContinueIterate:boolean;
                            IterateData:pointer; Tree:TCustomElTree);
  var Entry : PEntryRec;
      L, L1 : TStringList;
      gap : string;
      i : integer;
  begin
    Entry := PEntryRec(TElMTreeItem(Item.Data)^.Data);
    L := TStringList(IterateData);
    SetLength(gap, Item.Level*10);
    FillChar(gap[1], Length(gap), 32);
    if Entry.Group
     then L.Add(gap + 'Group name: '+ Entry.Site)
     else L.Add(gap + 'Site/Program name: '+ Entry.Site);
    if not Entry.Group then
    begin
      if Entry.Location <> '' then L.Add(gap + 'Location/address: ' + Entry.Location);
      if Entry.UName <> '' then L.Add(gap + 'User name: ' + Entry.UName);
      if Entry.Acct <> '' then L.Add(gap + 'Account #: '+ Entry.Acct);
      if Entry.Pswd <> '' then L.Add(gap + 'Password: '+ Entry.Pswd);
      if pos(#13, Entry.Info)>0 then
      begin
        L1 := TStringList.Create;
        L1.Text:=Entry.Info;
        L.Add(gap + 'Additional info: '+ L1[0]);
        for i := 1 to L1.Count -1 do
        begin
          L.Add(Gap + '                 '+ L1[i]);
        end;
        L1.Free;
      end else
      begin
        if Entry.Info <> '' then L.Add(gap + 'Additional info: '+ Entry.Info);
      end;
    end;
    L.Add('');
  end;

begin
  L := nil;
  try
    L := TStringList.Create;
    L.Add('');
    L.Add('');
    L.Add('');
    L.Add('Password list from ' + FFileName);
    L.Add('');
    L.Add('');
    Screen.Cursor := crHourGlass;
    try
      AssignPrn(PrintText);        { associate text file to printer device }
      Rewrite(PrintText);  { create and open output file }
      ElTree.Items.Iterate(false, @IntPrepare, L);
      for i := 0 to L.Count -1 do
        Writeln(PrintText, StrToOEM(L[i])); { write each line to printer }
    finally
      Screen.Cursor := crDefault;
    end;  // try/finally
  finally
    L.Free;
    CloseFile(PrintText);
  end;
end;

procedure TLogoAppForm.ToTrayItemClick(Sender: TObject);
begin
  Options.ToTray := not Options.ToTray;
  ToTrayItem.Checked := Options.ToTray;
end;

procedure TLogoAppForm.RxTrayDblClick(Sender: TObject);
begin
  Application.Restore;
end;

procedure TLogoAppForm.AppEventsMinimize(Sender: TObject);
begin
  if Options.ToTray then
  begin
    Tray.Enabled:=true;
    ShowWindow(Application.Handle,SW_HIDE);
  end;
end;

procedure TLogoAppForm.AppEventsRestore(Sender: TObject);
begin
  if Options.ToTray then
  begin
    Tray.Enabled:=false;
    ShowWindow(Application.Handle,SW_RESTORE);
    Application.BringToFront;
  end;
end;

procedure TLogoAppForm.FormShow(Sender: TObject);
var bSucc : Boolean;
begin
  if Options.ReopenFile and (Options.LastFile <> '') and (not Options.SaveKeys) then
  begin
    if LoadFile(Options.LastFile, '', false) then
    begin
      FFileName := Options.LastFile;
      FChanged := false;
      FOpened := true;
      FormCaption.Texts[3].Caption := FFileName;
    end;
  end;
  if (ParamCount > 0) then
  begin
    if ParamCount > 1
       then bSucc := LoadFile(ParamStr(1), ParamStr(2), true)
       else bSucc := LoadFile(ParamStr(1), '', False);
    if bSucc then
    begin
      FFileName := ParamStr(1);
      FChanged := false;
      FOpened := true;
      FormCaption.Texts[3].Caption := FFileName;
    end;
  end;
end;

procedure TLogoAppForm.PasswItemClick(Sender: TObject);
begin
  Options.ShowPassword := not Options.ShowPassword;
  PasswItem.Checked := not PasswItem.Checked;
end;

procedure TLogoAppForm.ElMRUClick(Sender: TObject; Entry: TElMRUEntry);
begin
  if FOpened then
   if not FileClose then exit;
  if LoadFile(Entry.Name, '', false) then
  begin
    FFileName := Entry.Name;
    FChanged := false;
    FOpened := true;
    FormCaption.Texts[3].Caption := FFileName;
  end;
end;

procedure TLogoAppForm.FormCaptionButtonClick(Sender: TObject;
  Button: TElCaptionButton);
begin
  ElFormPersist.TopMost := Button.Down;
end;

procedure TLogoAppForm.CopyPswItemClick(Sender: TObject);
var C : TClipboard;
    Entry : PEntryRec;
begin
  if ElTree.ItemFocused = nil then exit;
  Entry := PEntryRec(TElMTreeItem(ElTree.ItemFocused.Data)^.Data);
  if Entry.Group then exit;
  C := TClipboard.Create;
  C.Open;
  C.AsText := Entry.Pswd;
  C.Close;
  C.Free;
end;

procedure TLogoAppForm.ElFormPersistRestore(Sender: TObject);
begin
  FormCaption.Buttons[0].Down := ElFormPersist.TopMost;
end;

procedure TLogoAppForm.KeepPswItemClick(Sender: TObject);
begin
  KeepPswItem.Checked := not KeepPswItem.Checked;
  Options.KeepPassword := KeepPswItem.Checked;
end;

procedure TLogoAppForm.SetPswItemClick(Sender: TObject);
var Passw : string;
begin
  PasswordDlg.Password.Text:='';
  PasswordDlg.ConfPassword.visible:=true;
  PasswordDlg.ConfLabel.Visible:=true;
  PasswordDlg.ConfPassword.Text:='';
  repeat
    if PasswordDlg.ShowModal = mrCancel then exit;
    if PasswordDlg.Password.Text<>PasswordDlg.ConfPassword.Text then
      MessageDlg (LoadStr(sPswNotMatch), mtError, [mbOk], 0)
    else
    if PasswordDlg.Password.Text='' then
       MessageDlg (LoadStr(sPswEmpty), mtError, [mbOk], 0)
    else break;
  until false;
  Passw := PasswordDlg.Password.Text;
  PasswordDlg.Password.Text:='';
  PasswordDlg.ConfPassword.Text:='';
  FilePassword := Passw;
  SaveFile(FFileName);
end;

procedure TLogoAppForm.ReopenFileItemClick(Sender: TObject);
begin
  ReOpenFileItem.Checked := not ReOpenFileItem.Checked;
  Options.ReopenFile := ReOpenFileItem.Checked; 
end;

procedure TLogoAppForm.ParanoyaItemClick(Sender: TObject);
begin
  ParanoyaItem.Checked := not ParanoyaItem.Checked;
  Options.SaveKeys := ParanoyaItem.Checked;
end;

end.
