unit frmRecProp;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, ShellApi, OleDrop, 
  Menus;

type PEntryRec = ^TEntryRec;
     TEntryRec = record
       Group    : boolean;
       Site,
       Location,
       UName,
       Acct,
       Pswd,
       Info     : string;
     end;

type
  TRecPropsForm = class(TForm)
    OKBtn: TButton;
    CancelBtn: TButton;
    Panel1: TPanel;
    Label1: TLabel;
    SiteNameEdit: TEdit;
    Label2: TLabel;
    URLEdit: TEdit;
    Label3: TLabel;
    UNameEdit: TEdit;
    Label4: TLabel;
    AcctEdit: TEdit;
    Label5: TLabel;
    PswEdit: TEdit;
    Label6: TLabel;
    InfoMemo: TMemo;
    GoBtn: TButton;
    PswGenBtn: TButton;
    procedure URLEditChange(Sender: TObject);
    procedure GoBtnClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure SiteNameEditDragDrop(Sender, Source: TObject; X, Y: Integer);
    procedure SiteNameEditDragOver(Sender, Source: TObject; X, Y: Integer;
      State: TDragState; var Accept: Boolean);
    procedure URLEditDragOver(Sender, Source: TObject; X, Y: Integer;
      State: TDragState; var Accept: Boolean);
    procedure URLEditDragDrop(Sender, Source: TObject; X, Y: Integer);
    procedure PswGenBtnClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    Entry : PEntryRec;
    FSNDropTarget,
    FLDropTarget : IWCDroptarget;
    procedure GetData;
    procedure SetData;
  end;

var
  RecPropsForm: TRecPropsForm;

implementation

uses frmPswGen;

procedure TRecPropsForm.GetData;  { public }
begin
  Entry^.Site:=SiteNameEdit.Text;
  Entry^.Location:=URLEdit.Text;
  Entry^.UName:=UNameEdit.Text;
  Entry^.Acct:=AcctEdit.Text;
  Entry^.Pswd:=PswEdit.Text;
  Entry^.Info:=InfoMemo.Text;
end;  { GetData }

procedure TRecPropsForm.SetData;  { public }
begin
  SiteNameEdit.Text:=Entry^.Site;
  URLEdit.Text:=Entry^.Location;
  UNameEdit.Text:=Entry^.UName;
  AcctEdit.Text:=Entry^.Acct;
  PswEdit.Text:=Entry^.Pswd;
  InfoMemo.Text:=Entry^.Info;
end;  { SetData }

{$R *.DFM}

procedure TRecPropsForm.URLEditChange(Sender: TObject);
begin
  GoBtn.Enabled:=UrlEdit.Text<>'';
end;

procedure TRecPropsForm.GoBtnClick(Sender: TObject);
begin
  ShellExecute(0,'open',PChar(UrlEdit.Text),nil, nil, SW_SHOWNORMAL);
end;

procedure TRecPropsForm.FormCreate(Sender: TObject);
begin
  FSNDropTarget := IWCDroptarget.Create(SiteNameEdit);
  FLDropTarget := IWCDroptarget.Create(URLEdit);
end;

procedure TRecPropsForm.FormDestroy(Sender: TObject);
begin
  FSNDropTarget.Free;
  FLDropTarget.Free;
end;

procedure TRecPropsForm.SiteNameEditDragDrop(Sender, Source: TObject; X,
  Y: Integer);
var i : Integer;
begin
  if Source is ToleDragObject then
  begin
    i:=ToleDragObject(source).DragContent;
    if i=CF_Text then SiteNameEdit.Text:= ToleDragObject(source).StringData;
  end;
end;

procedure TRecPropsForm.SiteNameEditDragOver(Sender, Source: TObject; X,
  Y: Integer; State: TDragState; var Accept: Boolean);
begin
  if Source is ToleDragObject then accept := true else Accept := false;
end;

procedure TRecPropsForm.URLEditDragOver(Sender, Source: TObject; X,
  Y: Integer; State: TDragState; var Accept: Boolean);
begin
  if Source is ToleDragObject then accept := true else Accept := false;
end;



procedure TRecPropsForm.URLEditDragDrop(Sender, Source: TObject; X,
  Y: Integer);
var i : Integer;
begin
  if Source is ToleDragObject then
  begin
    i:=ToleDragObject(source).DragContent;
    if i=CF_Text then URLEdit.Text:= ToleDragObject(source).StringData;
  end;
end;

procedure TRecPropsForm.PswGenBtnClick(Sender: TObject);
begin
  PswGenForm := TPswGenForm.Create(nil);
  if PswGenForm.ShowModal = mrOk then
  begin
    PswEdit.Text := PswGenForm.Pssw;
  end;
  PswGenForm.Free;
  PswGenForm := nil;
end;

end.

